/******************************************************************

 This is a 'navigator' its job is to provide basic content
    specific navigation, things like nextLine, prevline, 
    line begin and lineend pointers
 
 Dont use tab characters in this source
  Dont use tab characters in this source
   Dont use tab characters in this source
    Dont use tab characters in this source
     Dont use tab characters in this source
      Dont use tab characters in this source
       Dont use tab characters in this source
        Dont use tab characters in this source
         Dont use tab characters in this source
          Thanks.
 
 mothods:
  // setup classes
  int       SetAccumulator  ( Accumulator * accum = NULL );
 
  // content search
  ChrOffset LinePos         ( void ) ;
  ChrOffset LineEnd         ( ChrOffset ) ;
  ChrOffset NextLine        ( ChrOffset ) ;
  ChrOffset PrevLine        ( ChrOffset ) ;
  
 --================| change log ==============--
 
 Feb 17 2002  Dan Williams, Created. note: NOT CONCURRENT
 [bunch of stuff missing here]
 mar 10 2002  dan, Added prevline method.
 mar 10 2002  dan, Added range checking to seek.
 mar 10 2002  dan, added lineEnd
 nov 29 2002  dan, stripped down contentfilter to become navigator
 Dec 13 2003: Fixed for gcc 3.3 dan 
 dec 30 2011  converted to C
 feb 8, 2021  added FwdLines and BackLines, made Next and Prev compt. shells.

*******************************************************************/

#include <stdlib.h>
#include <string.h> // strchr
#include "navigator.h"
#include "accumulator.h"
#include "cestypes.h" // MIN


/************************************

  Initialize the thing.

************************************/
void  NavInit ( Nav_t * this){
   this->accumulator= NULL;
}

/************************************

  Clean up.

************************************/
void  NavFini ( Nav_t * this) {
}

/*************************************

  Set the accumulator

*************************************/
void  NavSetAccumulator ( Nav_t * this, tac_t * accum){
    this->accumulator = accum;
}



/***********************************************

Report the length of the line that the cursor 
  is currently on.

***********************************************/

ChrOffset NavLineLength ( Nav_t * this, ChrOffset position){
  ChrOffset retval = 0;
  ChrOffset t;
  
  retval =  NavLineEnd  ( this, position );
//  fprintf(stderr, "lineEnd: %d ", retval);
  t = NavBackLines( this, position,0);
//  fprintf(stderr, "lineEnd: %d \n", t);
  return retval - t;

}



/***********************************************

Report the cursor position in a line that the cursor 
  is currently on.

  notes:
  
   - error handling would be a good thing...
   
   \nlsfjdllkfdldsflkjasfjk\n
     ^        ^          
     0        9

!!!???!!! rewrite! grab a block of 80 or less and check that

***********************************************/
ChrOffset NavLinePos  ( Nav_t * this, ChrOffset position){
  
  char buffer[2] = "";
  ChrOffset retval = -1;
    
  do {
    TACReadN ( this->accumulator, position, buffer, 1 , NULL);
    
    if (buffer[0] != '\n')   retval++; 
      
  } while (( buffer[0] != '\n' ) && ( position-- > 0 ));
  
  
 return( retval );
 
}

/*******************************************

  Return the position of the last character 
    of the current line. This is measured 
    from blockstart.
    
    \nlsafdlsfjlkfhksg\nfksfiewoiutrkjnsciou\n
         ^           ^
       start      result

*******************************************/
ChrOffset NavLineEnd  ( Nav_t * this, ChrOffset position){

 int found = 0; 
 ChrOffset dataEnd;
 char buffer[2] = "";

 dataEnd  = this->accumulator->contentSize;

 //position++;

 while (found == 0) { 
 
   if (position > dataEnd)     // return EOF
     return ( position - 1);
 
   TACReadN ( this->accumulator, position, buffer, 1 , NULL); // read a byte
 
   if ( buffer[0] == '\n' ) 
     found = 1;
   else 
     position++;            // next byte
 
 } // end while

 return ( position /*- 1*/) ;

}

/*******************************************

  Return the position of the first character 
    of the next line.
    
    \nlsafdlsfjlkfhksg\nfksfiewoiutrkjnsciou\n
         ^              ^
       start         result

  
*******************************************/

ChrOffset NavNextLine ( Nav_t * this, ChrOffset position){
  return NavFwdLines ( this,  position, 1);
}



ChrOffset NavFwdLines       ( Nav_t * this, ChrOffset position, unsigned int lines) {
 // this is slow, but using the new-legal methods
  
  char buffer[2] = "";
  ChrOffset dataEnd;
  unsigned int lineCount = 0;
  
  dataEnd  = this->accumulator->contentSize;
  
  for ( ;(( lineCount < lines ) && ( position < dataEnd )); position++) {
 
    TACReadN (this->accumulator, position, buffer, 1, NULL );
    
    if (buffer[0] == '\n')   lineCount++;
   }       
  
 return( position );

}




/*******************************************

  Return the position of the first character 
    of the previous line.
    
    \nlsafdlsfjlkfhksg\nfksfiewoiutrkjnsciou\n
      ^                             ^
     result                        start               

    asdaf\nlsafdlsfjlkfhksg\nfksfiewoiutrkjnsciou\n
    ^             ^
   result         start
   
    \nlsafdlsfjlkfhksg\nfksfiewoiutrkjnsciou\n
    ^             ^  
    result      start

  works by stopping on 2n'd \n or BOF
  
  
  Use NavBackLines( , , 0) to get pointer to start of current line.
  
*******************************************/

ChrOffset NavPrevLine       ( Nav_t * this, ChrOffset position) {
  return NavBackLines  (  this,  position, 1);
}


ChrOffset NavBackLines       ( Nav_t * this, ChrOffset position, unsigned int lines) {
 // this is slow, but using the new-legal methods
  
  char buffer[2] = "";

  unsigned long lineCount = 0;
  
  for (   ; ( lineCount < lines ) && ( position != 0 )   ;  position --  ) {
    TACReadN (this->accumulator, position, buffer, 1, NULL );
    if (buffer[0] == '\n')   lineCount++;    
  }
  
 return( position  );

}



ChrOffset NavXY2Offset ( Nav_t * this, unsigned int X, unsigned int Y) {
    ChrOffset crs;
    
    crs = 0;
    if (Y != 0)   crs = NavFwdLines (this, 0, Y);  
    if (crs == this->accumulator->contentSize) return crs;
   
    crs += Min(NavLineLength (this, crs) , X);
    return crs;

}


//-------------------------| Junk bin |-------------------------

/*

ChrOffset NavPrevLine       ( Nav_t * this, ChrOffset position) {

 // this is slow, but using the new-legal methods
  
  char buffer[2] = "";

  char lineCount = 0;
  
  position++;
  
  do {
 
    position --;

    TACReadN (this->accumulator, position, buffer, 1, NULL );
    
    if (buffer[0] == '\n') {
      lineCount++;
    }
    
   } while (( lineCount < 2 ) && ( position != 0 ));  // count back to linefeed or BOF
  
   if (lineCount == 2) { // if we stoped because we found a normal begginig, 
      position++;        //  adjust to first character of that line.
   }
  
 return( position );

}


ChrOffset NavNextLine ( Nav_t * this, ChrOffset position){

 int found = 0; 
 ChrOffset dataEnd;
 char buffer[2] = "";

 dataEnd  = this->accumulator->contentSize;

 position++;

 while (found == 0) { 
 
   if (position > dataEnd) // die if EOF
     return -1;
 
  TACReadN ( this->accumulator, position, buffer, 1 , NULL); // read a byte
 
   if ( buffer[0] == '\n') 
     found = 1;

     position++;            // next byte
 
 } // end while

 return position ;
 
}


















*/


