

int editorReadKey(Editor_t * E) { // this needs to be a state machine for collecting the escape seq
  int nread;
  char c[33];
  char * cp;
  
  cp = &c[0];
  
  while ((nread = read(STDIN_FILENO, cp, 1)) != 1) {       // get first character
    if ((nread == -1) && (errno != EAGAIN)) die("read");
    if (E->tmpMessage) 
      if (time(NULL) > E->messageExpire) return TIMER_EVENT;         // trip out for status bar to reset.
  } 
   
  if ((c[0] >= 0x20) && (c[0] <= 0x7F))    return c[0];     // normal character
  if  (c[0] != '\e')                       return extCharLookup(c[0]); 
  
  cp++;  
  if (read(STDIN_FILENO, cp, 1) != 1)      return '\e'; // error fallback
  
  if (*cp == '\e')                         return '\e'; // double escape
  
  if ((*cp == '[' ) || (*cp == 'O' ) )  {
    do { 
      cp++;
      if (read(STDIN_FILENO, cp, 1) != 1)  return 0; // error   
      
      if (*cp == 'M') {  // mouse event
        cp++; if (read(STDIN_FILENO, cp, 1) != 1)  return 0; // button
        cp++; if (read(STDIN_FILENO, cp, 1) != 1)  return 0; // X loc
        cp++; if (read(STDIN_FILENO, cp, 1) != 1)  return 0; // Y loc
       // fprintf(stderr, "Mouse Event: button: %X X:%d Y:%d\n", (unsigned char)c[3], (unsigned char)c[4], (unsigned char)c[5]);
        M.buttons = c[3];  M.X = c[4]; M.Y = c[5];
        return MOUSE_EVENT; // I dont know what to DO with the data yet.
      }      
      
//      fprintf(stderr, "-> %c", *cp);               
    } while( (*cp == ';') || (isdigit(*cp)) );
    cp++;
    *cp = 0;
    
    return escKeyLookup( &c[1] );
  
  }

}



//-----------------------------------------------------------------------------------------------------



typedef enum EventType_e {  
   EVENT_NONE,
   EVENT_KEYSTROKE,
   EVENT_MOUSE,
   EVENT_TIMER,
   EVENT_CUSTOM,
   
   EVENT_LIST_END

 } EventType_t;
 
 
 /*
   keyboard event:  int key
   mouse event:     int buttons, int x, int y
   Event timer:     
   
 
 
 */



int stdinFSM(char * c) {
  
  static int state = 0;
  int b[32];
  static int i = 0;
  
  switch (state) {
  
    case 0: // first character
      if ((c >= 0x20) && (c <= 0x7F))    return c;     // normal character
      if  (c != '\e')                    return extCharLookup(c); 
      state = 1;
    break;
    
    case 1:
      if (c == '\e')  {                   state = 0;   return '\e'; } // double escape
      if ((c == '[' ) || (c == 'O' ) )  { state = 2;   b[0] = c;  i = 1;  }
      state = 0;   // error
    break;    

    case 2:
      if (c == 'M')  state = 10;   // mouse event     
      if( (c == ';') || (isdigit(c)) ) { state = 3; b[i] = c; i++;  } 
      state = 0;   // error  
    break;
    
    case 3:
      if (0) {
      } else if( (c == ';') || (isdigit(c)) ) { 
        b[i] = c; i++;  
      } else {
        b[i] = c; i++;
        b[i] = 0;
        state = 0;
        return escKeyLookup( b[0] ); 
      }      
    break;
            
    case 10:
      b[0] = c;
      state = 11;
    break;
    
    case 11:
      c[1] = c;
      state = 12;
    break;     
  
    case 12:
      c[2] = c;
      state = 0;
      M.buttons = b[0];  M.X = b[1]; M.Y = b[2];
      return MOUSE_EVENT;
    break;
  
  }


  return EVENT_NONE;

}













